package rainmelt;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.java_websocket.WebSocket;

public enum HandlerManager {
	
	INSTANCE;

	private final Map<WebSocket, Handler> map = new HashMap<WebSocket, Handler>();
	
	public synchronized Handler get(final WebSocket key) {
		return map.get(key);
	}
	
	public synchronized void put(final WebSocket key, final Handler value) {
		map.put(key, value);
	}
	
	public synchronized void remove(final WebSocket key) {
		map.remove(key);
	}
	
	public synchronized Collection<Handler> getValues() {
		return new ArrayList<Handler>(map.values());
	}
	
}
