package rainmelt.fileapi;

import java.io.File;

import rainmelt.Handler;
import rainmelt.packet.FileAPIPacket;
import rainmelt.packet.FileExceptionPacket;

public final class createDirectory implements FileAPI {

	@Override
	public void execute(final Handler handler, final FileAPIPacket packet) {
		if (packet.args.length < 1) {
			final FileExceptionPacket p = new FileExceptionPacket(packet.id, FileExceptionPacket.Type.TOO_FEW_ARGUMENTS);
			handler.send(p);
			return;
		}
		
		final File file = handler.getFileSystem().toFile(packet.args[0]);
			
		if (!file.mkdirs()) {
			final FileExceptionPacket p = new FileExceptionPacket(packet.id, FileExceptionPacket.Type.FAILED_TO_CREATE);
			handler.send(p);
			return;
		}
	}

}
