package rainmelt.fileapi;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import net.tootallnate.websocket.Base64;
import rainmelt.Handler;
import rainmelt.packet.FileAPIPacket;
import rainmelt.packet.FileExceptionPacket;
import rainmelt.packet.ResultPacket;

public final class save implements FileAPI {

	@Override
	public void execute(final Handler handler, final FileAPIPacket packet) {
		if (packet.args.length < 2) {
			final FileExceptionPacket p = new FileExceptionPacket(packet.id, FileExceptionPacket.Type.TOO_FEW_ARGUMENTS);
			handler.send(p);
			return;
		}
		
		final File file = handler.getFileSystem().toFile(packet.args[0]);
		
		try {
			final BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(file));
			final byte[] b = Base64.decode(packet.args[1]);
			out.write(b);
			out.close();
			final ResultPacket r = new ResultPacket(packet.id, ResultPacket.Status.SUCCESS, "");
			handler.send(r);
		} catch (final IOException e) {
			e.printStackTrace();
			final FileExceptionPacket p = new FileExceptionPacket(packet.id, FileExceptionPacket.Type.IO_ERROR);
			handler.send(p);
			return;
		}
	}

}