package rainmelt.fileapi;

import java.io.File;

import rainmelt.Handler;
import rainmelt.packet.FileAPIPacket;
import rainmelt.packet.FileExceptionPacket;
import rainmelt.packet.FileStatusPacket;

public final class status implements FileAPI {

	@Override
	public void execute(final Handler handler, final FileAPIPacket packet) {
		if (packet.args.length < 1) {
			final FileExceptionPacket p = new FileExceptionPacket(packet.id, FileExceptionPacket.Type.TOO_FEW_ARGUMENTS);
			handler.send(p);
			return;
		}
		
		final File file = handler.getFileSystem().toFile(packet.args[0]);
		
		final FileStatusPacket p = new FileStatusPacket(packet.id, file);
		handler.send(p);
	}

}
