package rainmelt.packet;

import java.util.ArrayList;
import java.util.List;

public final class AccountListPacket {

	public String id;
	public String opcode = "AccountList";
	
	public final List<Entry> list = new ArrayList<Entry>();
	
	@SuppressWarnings("unused")
	private AccountListPacket() {
	}
	
	public AccountListPacket(final String id) {
		this.id = id;
	}
	
	public void add(final String name) {
		list.add(new Entry(name));
	}
	
	private final class Entry {
		
		@SuppressWarnings("unused")
		public String name;
		
		public Entry(final String name) {
			this.name = name;
		}
		
	}
	
}
