package rainmelt.packet;

import java.util.ArrayList;
import java.util.List;

public final class CompletionPacket {

	public String id;
	public String opcode = "Completion";
	
	public String directory;
	public final List<Entry> list = new ArrayList<Entry>();
	
	@SuppressWarnings("unused")
	private CompletionPacket() {
	}
	
	public CompletionPacket(final String id) {
		this.id = id;
	}
	
	public void add(final Type type, final String name) {
		list.add(new Entry(type, name));
	}
	
	public enum Type {
		DIRECTORY,
		FILE,
		;
	}
	
	private final class Entry {
		
		@SuppressWarnings("unused")
		public Type type;
		@SuppressWarnings("unused")
		public String name;
		
		public Entry(final Type type, final String name) {
			this.type = type;
			this.name = name;
		}
		
	}
	
}
