package rainmelt.packet;

public final class FileExceptionPacket {

	public String id;
	public String opcode = "FileException";
	
	public Type type;
	
	public enum Type {
		SUCCESS,
		IO_ERROR,
		TOO_FEW_ARGUMENTS,
		NOT_EXIST,
		IS_FILE,
		IS_DIRECTORY,
		UNKNOWN_TYPE,
		FAILED_TO_DELETE,
		FAILED_TO_CREATE,
	}
	
	@SuppressWarnings("unused")
	private FileExceptionPacket() {
	}
	
	public FileExceptionPacket(final String id, final Type type) {
		this.id = id;
		this.type = type;
	}
	
}
