package rainmelt.packet;

import java.io.File;

public final class FileStatusPacket {

	public String id;
	public String opcode = "FileList";
	
	public enum Type {
		DIRECTORY,
		FILE,
		OTHER,
		NULL,
	}
	
	public Type type;
	public String name;
	public long size;
	
	@SuppressWarnings("unused")
	private FileStatusPacket() {
	}
	
	public FileStatusPacket(final String id, final File file) {
		this.id = id;
		if (!file.exists()) {
			type = Type.NULL;
			name = "";
			size = 0;
		} else if (file.isDirectory()) {
			type = Type.DIRECTORY;
			name = file.getName();
			size = 0;
		} else if (file.isFile()) {
			type = Type.FILE;
			name = file.getName();
			size = file.length();
		} else {
			type = Type.OTHER;
			name = file.getName();
			size = 0;
		}
	}
	
}
